<template>
  <form class="form">
    <TextInput
      label="Name"
      v-model="form.name"
      @input="validation('name')"
      :error="$v.name.$errors?.[0]?.$message.toString()"
    />
    <TextInput
      label="Email"
      v-model="form.email"
      @input="validation('email')"
      :error="$v.email.$errors?.[0]?.$message.toString()"
    />
    <TextInput
      label="Password"
      is-password
      v-model="form.password"
      @input="validation('password')"
      :error="$v.password.$errors?.[0]?.$message.toString()"
    />
    <TextInput
      label="Confirm"
      is-password
      v-model="form.confirm"
      @input="validation('confirm')"
      :error="$v.confirm.$errors?.[0]?.$message.toString()"
    />
    <div class="flex gap-x-5">
      <button class="btn" @click.prevent="submitForm">Send</button>
      <button class="btn" @click.prevent="refreshForm">Refresh</button>
    </div>
  </form>
</template>

<script setup lang="ts">
import { useAuthStore } from "@/stores/auth";
import { useVuelidate } from "@vuelidate/core";
import { required, minLength, maxLength, email, sameAs } from "@vuelidate/validators";
import { storeToRefs } from "pinia";

const { Registration } = useAuthStore();
const { USER } = storeToRefs(useAuthStore());

const form = reactive({
  name: "",
  email: "",
  password: "",
  confirm: ""
});

const rules = computed(() => ({
  name: {
    required,
    minLength: minLength(3),
  },
  email: {
    required,
    minLength: minLength(3),
    maxLength: maxLength(100),
    email,
  },
  password: {
    required,
    minLength: minLength(8),
    maxLength: maxLength(100),
  },
  confirm: {
    required,
    minLength: minLength(8),
    maxLength: maxLength(100),
    sameAs: sameAs(form.password, 'password')
  },
}));

const $v = useVuelidate(rules, form);

const submitForm = () => {
  $v.value.$touch();
  const canSubmit = Object.values(form).every((e) => e);
  const formIsValid = !$v.value.$invalid;
  if (canSubmit && formIsValid) tryToLogin();
};

const tryToLogin = async () => {
  try {
    await Registration(form);
    refreshForm();
  } finally {
    console.log("USER", USER.value);
  }
};

const validation = (inputName: string) => {
  $v.value[inputName].$touch();
};

const refreshForm = () => {
  const keys = Object.keys(form);
  keys.forEach((key: string) => {
    // галімий TS не приймає form[key] тому треба городити ось таку фігню form[key as keyof typeof form]
    form[key as keyof typeof form] = "";
  });
  $v.value.$reset();
};
</script>
